/*
hputblk.c Version 0.1.0  Hash write database block
Copyright (C) 2003  dondalah@ripco.com (Dondalah)

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to:

	Free Software Foundation, Inc.
	59 Temple Place - Suite 330
	Boston, MA  02111-1307, USA.
*/

#include <bthash.h>

void hputblk(hashfmt *hshhdr, long ofst,
   h_nodefmt *blk)
   {
   BOOL  bResult;
   DWORD msgerr;
   LPVOID lpMsgBuf;
   DWORD wrtlen;
   long loc;
   hshhdr->reason = 0;
   loc = hseek(hshhdr,ofst);
   if (hshhdr->reason) return;
   bResult = WriteFile(hshhdr->hndl,
      (unsigned char *) blk,
      (DWORD) hshhdr->rcdnode,
      &wrtlen, NULL);
   if (!bResult)
      {
      msgerr = GetLastError();
      hshhdr->reason = SYS_ERR + msgerr;
      FormatMessage(FORMAT_MESSAGE_ALLOCATE_BUFFER |
         FORMAT_MESSAGE_FROM_SYSTEM |
         FORMAT_MESSAGE_IGNORE_INSERTS,
         NULL,           /* source */
         msgerr,
         MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT),
         (LPTSTR) &lpMsgBuf,
         0,              /* msglen */
         NULL);          /* insertion values */
      fprintf(stderr,"hputblk: %s\n", lpMsgBuf);
      LocalFree(lpMsgBuf);
      fprintf(stderr,"hputblk: msgerr %d\n", msgerr);
      hshhdr->reason = SYS_ERR + msgerr;
      return;
      } /* write error */
   if (wrtlen == (DWORD) hshhdr->rcdnode)
      return;
   else
      {
      fprintf(stderr,"Write error (wrtlen %d)", wrtlen);
      hshhdr->reason = HASH_ERR + 1501;
      return;
      } /* write error */
   } /* hputblk */
